# atomic_base.h File Reference

Go to the source code of this file.

## Namespaces

- namespace std

## Defines

- #define _ATOMIC_CMPEXCHNG_(__a, __e, __m, __x)
- #define _ATOMIC_LOAD_(__a, __x)
- #define _ATOMIC_MODIFY_(__a, __o, __m, __x)
- #define _ATOMIC_STORE_(__a, __m, __x)
- #define _GLIBCXX_ATOMIC_BASE_H
- #define _GLIBCXX_ATOMIC_NAMESPACE
- #define _GLIBCXX_ATOMIC_PROPERTY
- #define ATOMIC_ADDRESS_LOCK_FREE
- #define ATOMIC_FLAG_INIT
- #define ATOMIC_INTEGRAL_LOCK_FREE

## Typedefs

- typedef struct
  std::__atomic_flag_base std::__atomic_flag_base
- typedef atomic_short std::atomic_int_fast16_t
- typedef atomic_int std::atomic_int_fast32_t
- typedef atomic_llong std::atomic_int_fast64_t
- typedef atomic_schar std::atomic_int_fast8_t
- typedef atomic_short std::atomic_int_least16_t
- typedef atomic_int std::atomic_int_least32_t
- typedef atomic_llong std::atomic_int_least64_t
- typedef atomic_schar std::atomic_int_least8_t
- typedef atomic_llong std::atomic_intmax_t
- typedef atomic_long std::atomic_intptr_t
- typedef atomic_long std::atomic_ptrdiff_t
- typedef atomic_ulong std::atomic_size_t
- typedef atomic_long std::atomic_ssize_t
- typedef atomic_ushort std::atomic_uint_fast16_t
- typedef atomic_uint std::atomic_uint_fast32_t
- typedef atomic_ullong std::atomic_uint_fast64_t
- typedef atomic_uchar std::atomic_uint_fast8_t
- typedef atomic_ushort std::atomic_uint_least16_t
- typedef atomic_uint std::atomic_uint_least32_t
- typedef atomic_ullong std::atomic_uint_least64_t
- typedef atomic_uchar std::atomic_uint_least8_t
- typedef atomic_ullong std::atomic_uintmax_t
- typedef atomic_ulong std::atomic_uintptr_t
- typedef enum std::memory_order std::memory_order

## Enumerations

- enum std::memory_order {
  memory_order_relaxed, memory_order_consume, memory_order_acquire, memory_order_release,
  memory_order_acq_rel, memory_order_seq_cst
  }

## Functions

- void std::__atomic_flag_wait_explicit (__atomic_flag_base *, memory_order) _GLIBCXX_NOTHROW
- std::__attribute__ ((__const__)) __atomic_flag_base *__atomic_flag_for_address(const void *__z) _GLIBCXX_NOTHROW
- void std::atomic_flag_clear (__atomic_flag_base *__a)
- void std::atomic_flag_clear_explicit (__atomic_flag_base *, memory_order) _GLIBCXX_NOTHROW
- bool std::atomic_flag_test_and_set (__atomic_flag_base *__a)
- bool std::atomic_flag_test_and_set_explicit (__atomic_flag_base *, memory_order) _GLIBCXX_NOTHROW

## Detailed Description

This is a Standard C++ Library header.

Definition in file atomic_base.h.